package mi.hdm.recipes;

import mi.hdm.mealPlan.MealPlan;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.time.LocalDate;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NutritionCalculatorTest {
    List<RecipeComponent> ingredients = ValidObjectsPool.getValidIngredientList();
    Map<RecipeComponent, Integer> recipeMap;

    @BeforeEach
    public void setUp() {
        recipeMap = new HashMap<>();
        ingredients.forEach(ingredient -> recipeMap.put(ingredient, 100));
    }

    @Test
    public void testCalculateNutritionTableFromIngredients() {
        //given
        NutritionTable expected = new NutritionTable(363.1, 42.4, 9.6, 4.3, 2.4, 1.2);

        //when
        NutritionTable actual = NutritionCalculator.calculateNutritionTable(recipeMap);

        //expect
        Assertions.assertEquals(expected, actual);
    }

    @Test
    public void testCalculateNutritionTableFromMealPlan() {
        //given
        NutritionTable expected = new NutritionTable(876.2, 110.6, 33.3, 15.05, 8.4, 3);

        //when
        NutritionTable actual = NutritionCalculator.calculateNutritionTable(ValidObjectsPool.getValidMealPlanOne());

        //expect
        Assertions.assertEquals(expected, actual);
    }
}
